/*
  This file may be copied, modified and distributed only in accordance with
  the terms of the limited licence contained in the accompanying file <licence.txt>

*/
void appendauth( __u8 *string, unsigned int len,
        __u8 *key, unsigned int klen)
{
        MD5_CTX  context;
        unsigned char buf[256];
        unsigned char digest[16];

        bcopy (key, buf, klen);
        bcopy (string, buf+klen, len);
        bcopy (key, buf+klen+len, klen);

        MD5Init (&context);
        MD5Update (&context, buf, len+2*klen);
        MD5Final (digest, &context);
        bcopy (digest, string+len+4, 16);
}

/********************************************************************/


int in_cksum(addr, len)
unsigned short *addr;
int len;
{
        register int nleft = len;
        register unsigned short *w = addr;
        register int sum = 0;
        unsigned short answer = 0;

        /*
         * Our algorithm is simple, using a 32 bit accumulator (sum), we add
         * sequential 16 bit words to it, and at the end, fold back all the
         * carry bits from the top 16 bits into the lower 16 bits.
         */
        while (nleft > 1)  {
                sum += *w++;
                nleft -= 2;
        }

        /* mop up an odd byte, if necessary */
        if (nleft == 1) {

                *(u_char *)(&answer) = *(u_char *)w ;
                sum += answer;
        }

        /* add back carry outs from top 16 bits to low 16 bits */
        sum = (sum >> 16) + (sum & 0xffff);     /* add hi 16 to low 16 */
        sum += (sum >> 16);                     /* add carry */
        answer = ~sum;                          /* truncate to 16 bits */
        return(answer);
}


