/*
  This file may be copied, modified and distributed only in accordance with
  the terms of the limited licence contained in the accompanying file <licence.txt>

*/

void loadparameters (char *name)
{

  /*This procedure is called when the agent reads parameters from its con
    figuration file. See the README file in order to create a configuration 
    file.*/

  FILE *fd;
  char string[255];
  int value, i, range, foreign;
  struct authentication *index;

  if ((fd = fopen (name,"r")) == NULL)
     {
        printf ("Configuration file missing\a\a\n");
        exit (-1);
     }

  readtoken (fd, string, 1); /*Agent's IP address*/
  HomeA.Addr = ForeignA.COA = inet_addr(string);
  readtoken (fd, string, 1); /*Agent's MAC address*/
  sscanf (string, "%x:%x:%x:%x:%x:%x\n", &HomeA.hwAddress[0], &HomeA.hwAddress[1], &HomeA.hwAddress[2],
               &HomeA.hwAddress[3], &HomeA.hwAddress[4], &HomeA.hwAddress[5]);
  readtoken (fd, string, 1); /*Interface*/
  strcpy (interface,string);
  value = readtoken (fd, string, 0);
  foreign = readtoken (fd, string, 0);
  DEBUG (4) printf ("Number of MN ... %d\n", value);
  HomeA.supported = value; ForeignA.supported = foreign; 
  for (i=0; i<value ; i++)
   {
     readtoken (fd, string, 1);
     mynodes[i].Address = inet_addr(string);
     mynodes[i].SPI = readtoken (fd, string, 0);
     range = readtoken (fd, string, 0);
     readtoken (fd, string, 1);
     mynodes[i].MD5keylength = range;
     strcpy (mynodes[i].MD5key, string);
     DEBUG (4)
       printf ("key size for node %d is %d\nValue: %s\n",i, mynodes[i].MD5keylength, mynodes[i].MD5key);
   }
  value = readtoken (fd, string, 0);
  if (value) DEBUG(4) printf ("Relations between MN-FA or FA-HA\n");
  for (i=0; i<value;i++)
     {
       char address[20];
       index = (struct authentication *)malloc (sizeof(struct authentication));
       readtoken (fd, address, 1);
       index->Address = inet_addr(address);
       index->SPI = readtoken (fd, address, 0);
       index->MD5keylength = readtoken (fd, string, 0);
       readtoken (fd, index->MD5key, 1);
       DEBUG (4)
        {
          printf ("Authentification found:\nIP address %s\n",inet_ntoa (index->Address));
          printf ("Length: %d MD5key %s\n", index->MD5keylength, index->MD5key);
        }
       index->next = authen;
       authen = index;
     }

  fclose (fd); 
 
} 
