/*
  This file may be copied, modified and distributed only in accordance with
  the terms of the limited licence contained in the accompanying file <licence.txt>

*/

/*This file includes all the structures that mobile node and agents are using
 */


#define KEYLENGTH 128

#define MIPRegReq_S(x) (((x).flags & 0x0080))
#define MIPRegReq_B(x) (((x).flags & 0x0040))
#define MIPRegReq_D(x) (((x).flags & 0x0020))
#define MIPRegReq_M(x) (((x).flags & 0x0010))
#define MIPRegReq_G(x) (((x).flags & 0x0008))

#define MIPRegReq_S_Set(x,y) ((x) = ((x).flags | 0x0080))
#define MIPRegReq_B_Set(x,y) ((x) = ((x).flags | 0x0040))
#define MIPRegReq_D_Set(x,y) ((x) = ((x).flags | 0x0020))
#define MIPRegReq_M_Set(x,y) ((x) = ((x).flags | 0x0010))
#define MIPRegReq_G_Set(x,y) ((x) = ((x).flags | 0x0008))


struct advert
{
  unsigned char num_addr;
  unsigned char addr_entry;
  unsigned short Lifetime;
  unsigned char type;
  unsigned char length;
  unsigned short seq_num;
  unsigned short Life_advert;
  unsigned short flags;
  unsigned long COA;
};

struct MIPRegReq {	/*MIP registration requests are stored here*/
    unsigned char type;
    unsigned char flags;
    unsigned short lifetime;
    unsigned long Address;
    unsigned long homeAgent;
    unsigned long careOfAddress;
    unsigned long identification[2];
};

struct MIPRegRep {
    unsigned char type;
    unsigned char code;
    unsigned short lifetime;
    unsigned long Address;
    unsigned long homeAgent;
    unsigned long identification[2];
};

struct MNode {
    unsigned long Address;
    unsigned long Mask;
    unsigned long homeAgent;
    unsigned long careOfAddress; 
    unsigned short lifetime;
    unsigned long identification[2];
    unsigned char MD5key[KEYLENGTH];
    unsigned char MD5keylength;
    int index; 
    int status; /*0 means not connected, 1 connected & 2 waiting connection*/
    int timeout1; /*Used as lifetime to the HA & FA after registration. In
                    the meantime, in the registration procedure means
		    I've sent a packet to the HA and I'm waiting for an answer.
		    if this timeout expires, I delete the entry in fnode*/
    int port;
    unsigned long SPI;
}; 

struct FAvalues
{
unsigned long COA;
unsigned short seq_num;
unsigned short Lifetime;
unsigned short TimeBetweenAdverts;
unsigned short flags;
int supported;
#ifdef ARP_REPLIES
	unsigned char hwAddress[6];
#endif
};

struct HAvalues
{
unsigned long Addr;
unsigned short Lifetime;
unsigned long NetMask;
unsigned char hwAddress[6];
int supported;
};


struct authentication
  {
    unsigned long Address;
    unsigned long SPI;
    unsigned char MD5key[KEYLENGTH];
    unsigned char MD5keylength;
    struct authentication *next;
  };    

struct mobileNode
{
struct FAvalues FA;
struct HAvalues HA;
unsigned long Address;
unsigned long identification[2];
int FaOrHa,status;
unsigned char MD5key[64];
unsigned char MD5keylength;
int timeout,regTimeout,timerId;
#ifdef ARP_REPLIES
	int ARPRepTimeout;
#endif
struct authentication *MNFA;
unsigned long SPI;
int index;
unsigned char MAC[6];
};

unsigned long newId ()
{
static int temp;
struct timeval timev;

if (!temp)
 {
   gettimeofday(&timev, NULL);
   srandom ((int) timev.tv_usec);
   temp++;
 }

return (unsigned long)random();
}

struct authentication *authenAssociation (Address, p)
unsigned long Address;
struct authentication *p;

{
while (p != NULL)
 if (p->Address == Address) return p;
 else p = p->next;
return NULL;
}

/************************************************************************/

int readtoken (FILE *desc, char string[128], int value)
{
   char reading, tmp[200];
   int i;

   reading = fgetc(desc);

   while (( reading == ' ') || (reading == '\t') || (reading == '\n')
            || (reading == '\r') || (reading == '#'))
    {
      if (reading == '#')
            while (reading != '\n')
               reading = fgetc(desc);
      reading = fgetc(desc);
    }
   i=0;
   tmp [i++]=reading;
   while ((reading != ' ') && (reading!='\t') && (reading != '\n') && (reading != '\r'))
	tmp[i++] = reading = fgetc (desc);
   tmp[i-1]='\0'; 
   if (value) /*It means "a string is expected"*/
      strncpy (string, tmp,i);
   else
       return atoi(tmp); 
   return 0;
}


