/*
  This file may be copied, modified and distributed only in accordance with
  the terms of the limited licence contained in the accompanying file <licence.txt>

*/

/*This file stores all the functions that mobile node and the agents use
  to handle the necessary timers*/

#include <stdio.h>
#include <unistd.h>
#include <signal.h>
#include "timers.h"
#include "debug.h"

#define ALARMTIME 2 

struct timerList *timerChain;

int fiddling;
int timerId;

void *catchAlarm()
{
    /*
     * Go down the list of timers, decrementing the timeLeft count as we go.
     * Call any callbacks for timers that reach zero, and remove them from the
     * list
     */

    struct timerList *p;
    struct timerList *q;
    struct timerList *remove;
    DEBUG(5)
	printf ("Entry in catchAlarm\n");

    if (!fiddling)
	{
            fiddling = 1;
	    p=timerChain;
	    q=(struct timerList *)NULL;
	    
	    while (p != (struct timerList *)NULL)
	     {
		p->timeLeft-=ALARMTIME;
		p = p->next;
	     }

	    p = timerChain;
	    while (p != (struct timerList *)NULL)
		{
		    if (p->timeLeft <= 0)
			{
			    remove=(struct timerList *)malloc(sizeof(struct timerList));
			    bcopy (p,remove,sizeof(struct timerList));
			   
			    if (q == (struct timerList *)NULL)
				{
				    timerChain=p->next;
				    free(p);
				    p = timerChain;
				}
			    else
				{
				    q->next = p->next;
				    free(p);
				    p=q->next;
				}
			  (remove->callback)(remove->arg1, remove->arg2);
			  free (remove);
			  p = timerChain;
			  q = (struct timerList *)NULL;
			}
		    else
			{
			    q=p;
			    p=q->next;
			}
		}
          fiddling = 0;
	}
    else
	{
	    DEBUG(0)
		printf ("\a\acatchAlarm: fiddling lockout\n");
	}

    signal(SIGALRM, (void *)catchAlarm);
    alarm(ALARMTIME);
    
    return; 
}

void startTimers()
{
    fiddling = 0;
    timerId=0;
    numero = 0;
    signal(SIGALRM, (void *)catchAlarm);
    alarm(ALARMTIME);
}

int addTimer (timeleft, fn, arg1, arg2)
    int timeleft;
    void (*fn)();
    void *arg1;
    void *arg2;
{
    /*
     * Add a callback in 'timeleft' seconds
     */

    struct timerList *p;

    if (timeleft<=0) return -1;

    p=(struct timerList *)malloc(sizeof(struct timerList));

    p->timeLeft = timeleft;
    p->callback = fn;
    p->arg1 = arg1;
    p->arg2 = arg2;
    p->id = timerId;
    p->next = (struct timerList *)NULL;

    START_FIDDLING;

    if (timerChain == (struct timerList *)NULL)
	{
	    timerChain = p;
	}
    else
	{
	    p->next = timerChain;
	    timerChain = p;
	}

    END_FIDDLING;
    DEBUG (5) printf ("\t\tAdding a timer  %d\n",++numero);
    return timerId++;
}

int cancelTimer (Id)
    int Id;
{

    /*
     * Search for the timer with an ID of 'Id' and remove it from the list
     */

    struct timerList *p;
    struct timerList *q;
    int dunnit;

    DEBUG(5)
	printf ("cancelTimer: entered, ID = %d\n", Id);

    START_FIDDLING;

    p = timerChain;
    q = (struct timerList *)NULL;
    dunnit = 0;

    while ( p!= (struct timerList *)NULL)
	{
	    
	    if (p->id == Id)
		{
		    /* This is the one to nuke */

		    if (q == (struct timerList *)NULL)
			timerChain = p->next;
		    else
			q->next = p->next;
		    
		    free (p);
		    p = (struct timerList *)NULL;
		    dunnit = 1;
		}
	    else
		{
		    q = p;
		    p = p->next;
		}
	}

    END_FIDDLING;

    DEBUG(5)
     {
        if (dunnit) printf ("\t\tDeleting timer %d\n", --numero);
          else printf ("\aTimer has not been deleted\n");
     }
    return dunnit;
}

int number_of_timers()
{

  /*This function is not necessary. It is used at debuging time*/

   struct timerList *p;
   int ele=0;
   p = timerChain;

   while (p != (struct timerList *)NULL)
	{
		ele++;
		p = p->next;
	}
   return ele;
}


